##########################################################################
#	Update.py 	Blender 2.66a
#
#	Created by Florian Voelker (iFlowProduction)
#	Games, Downloads and co. at http://iflowproduction.eleven-games.org
#
#	Released under the Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported (CC BY-NC-SA 3.0).
#	http://creativecommons.org/licenses/by-nc-sa/3.0/
#	
#	Feel free to change it for your own application(s), but leave this 
#	Header and inform others about the license.
#	If you use this code, please include this information header and don't change the license.
#
#	If you have any questions, please contact me.
#
#	Version 1.1
##########################################################################

import urllib.request
import webbrowser

from bge import logic

#Activate/Deactivate the Debug and Error-visibility (1 = True/ 0 = False)
Debug = 0
Errors = 1

#Defines File
file = "//Config/Version.cfg"

#Defines the urls
url_Download = "http://iflowproduction.de/downloads/"
url_Check = "http://iflowproduction.de/Update_Service/NAFS-Race_Version.txt"

def openWebsite():

	webbrowser.open(url_Download)
	
	if Debug:
		print("Opened " + url_Download)

def readFile():
	cont = logic.getCurrentController()
	obj = cont.owner

	try:
		f = open(logic.expandPath(file), 'r')
		Version = str(f.readline()) #[:-1]
		f.close()
		if Debug:
			print("Loading Local-Version Successful!")
		
		return Version
	
	except:
		if Errors:
			print("Loading from File Failed!")
		return "Vers. load error!"
		
def vers_Server_Load():
	cont = logic.getCurrentController()
	scene = logic.getCurrentScene()
	objList = scene.objects
	obj = cont.owner
	
	l_vers = readFile()
	
	up_Text = objList['Version_Text']
	up_Text['Text'] = str("Vers "+l_vers)
	
	if Debug:
		print("Local: " + str(l_vers))
	
	try:
		request = urllib.request.Request(url_Check)
		response = urllib.request.urlopen(request)

		u_vers = response.read().decode('utf-8')

		if Debug:
			print ("Url: " + u_vers)
	except:
		if Errors:
			print("Loading URL-Version failed! Correct URL? Server online?")
		up_Text['Text'] = up_Text['Text'] + " -- Check Internet connection."
		return
		
	if u_vers > l_vers:
		print("Update available! :)")
		#openWebsite()
		up_Text['Text'] = up_Text['Text'] + " -- Update ["+u_vers+"] available! Click the Button.  (Webbrowser opens!)"
		logic.sendMessage("Update.Available")

def check():
	vers_Server_Load()